;****************************************************************
;Program testuje polohu TRIM1 a porovnv j s hodnotou         * 	
;nastavenou pomoc tlatek UP(BT2) a DOWN(BT3). Pokud je       * 
;hodnota nastaven TRIM1 vt, rozsvt se znak 1 na nejvy  * 
;jednotce sedmiseg. displeje, v opanm ppad se rozsvt 0.  *
;---------------------------------------------------------------*
;Nastaven EDUKITu BETA:				        *	
;TRIM1, DISPLAY: ON                                             * 
;ostatn: OFF							*
;Dal nastaven: -MCLR/RA5 je universln vstup		*
;---------------------------------------------------------------*
;autor: ASIX, Tom Musil		datum: 19.11.2002       *
;****************************************************************
w       equ     0               ;parametr instrukc
f       equ     1               ;parametr instrukc
pcl     equ     0x02 
status  equ     0x03            ;status je na adrese 0x03
porta   equ     0x05 
trisa   equ     0x05            ;adresa portu A
portb   equ     0x06 
trisb   equ     0x06            ;adresa portu B
cmcon   equ     0x1F
vrcon   equ     0x1F		;nastaven intern napov reference
disp1   equ     0x20            ;pamt pro 1 sedmisegmentovku
disp2   equ     0x21            ;pamt pro 2 sedmisegmentovku
disp3   equ     0x22            ;pamt pro 3 sedmisegmentovku
disp4   equ     0x23            ;pamt pro 4 sedmisegmentovku
rot1    equ     0x24		;pomocn registr
rot2    equ     0x25
rot3    equ     0x26
rot4    equ     0x27
cntrot  equ     0x28		;pomocn registr
cnttl   equ     0x29		;ta filtru tlatek 
tlreg   equ     0x2a		;registr tlatek
reg     equ     0x2b		;pomocn registr
vref    equ     0x2c		;pomocn registr
;*******************************************************
#define RP0     status,5 
#define RP1     status,6
#define C       status,0
#define Z       status,2
#define STR     portb,6		;signl strobe obvodu 4094
#define DATA    portb,7		;signl data obvodu 4094
#define CLK     portb,4 	;hodinov signl obvodu 4094
#define C1OUT   cmcon,6		;vstup prvnho kompartoru
#define UP      tlreg,4		;tlatko ->
#define DOWN    tlreg,7		;tlatko <-
;*******************************************************
	list    p = 16F627 
	__config 0x3F71         ;nastaven konfigurace
;*******************************************************
bnk0    macro
	bcf     RP0		;nastav banku 0
	bcf     RP1
	endm
bnk1    macro
	bsf     RP0		;nastav banku 1
	bcf     RP1
	endm
;******************************************************* 
	org     0x0000
	goto    Init
;******************************************************* 
Tab1    addwf   pcl,f           ;pite w k tai instrukc
	retlw   B'00000011'     ; zobraz 0
	retlw   B'10011111'     ; zobraz 1
	retlw   B'00100101'     ; zobraz 2
	retlw   B'00001101'     ; zobraz 3
	retlw   B'10011001'     ; zobraz 4
	retlw   B'01001001'     ; zobraz 5
	retlw   B'01000001'     ; zobraz 6
	retlw   B'00011111'     ; zobraz 7
	retlw   B'00000001'     ; zobraz 8
	retlw   B'00001001'     ; zobraz 9
	retlw   B'11111111'	; przdn displej
;*******************************************************
Displej movlw   0x0a
	movwf   disp2		;disp2 bude zhasnut 
	movf    vref,w		;hodnota nastaven intern reference
	movwf   disp1		;se ulo od disp1  
	movlw   0x0a
	subwf   vref,w
	btfss   C		;pokud je nastaven reference > 9
	goto    Disp_A
	movwf   disp1		;pak se do disp1 ulo hodnota o 10 men
	movlw   0x01		 
	movwf   disp2 		;a do disp 2 se zape jednika
Disp_A  bcf     STR		;strobe do L
	movf    disp1,w		;podle hodnoty v disp1 se vygeneruje
	call    Tab1		;kd znaku
	movwf   rot1
	movf    disp2,w		;podle hodnoty v disp2 se vygeneruje
	call    Tab1		;kd znaku
	movwf   rot2
	movf    disp3,w
	call    Tab1
	movwf   rot3
	movf    disp4,w
	call    Tab1
	movwf   rot4
	movlw   0x20		;smyka probhne 32x (4 sedmisegmentovky
	movwf   cntrot		;po 8 bitech)
Disp_B  rrf     rot1,f		;rotace 32 bitovho registru (4x8)
	rrf     rot2,f
	rrf     rot3,f
	rrf     rot4,f
	bsf     DATA		;data do H
	btfss   C		
	bcf     DATA		;pokud je C=L, pak data do L
	bcf     CLK		;hodiny do L
	nop
	bsf     CLK		;nbn hrana hodin (zpis dat)
	decfsz  cntrot,f	;testovn konce smyky	
	goto    Disp_B		;skok na zatek smyky
	bsf     STR		;strobe do L (pepsn dat z registru
	return 			;obvod 4094 na vstup)
;*******************************************************
Cti_tl  bnk1                    ;vy strnka pamti dat
	movlw   B'10101111'    	  
	movwf   trisb
	movlw   B'11111111'
	movwf   trisa	        ;piny tlatek jsou vstupn 	
	bnk0                   
	movlw   0x0A 
	movwf   cnttl           ;nastaven filtru zkmit tlatek
	movf    portb,w         ;peten stavu portu B
	andlw   B'10000000'     ;zamaskovn nepotebnch bit
	movwf   tlreg           ;uloen stavu tlatka DOWN
	movf    porta,w         ;peten stavu portu A
	andlw   B'00010000'     ;zamaskovn nepotebnch bit
	iorwf   tlreg,f		;uloen stavu tlatka UP	        	
Cti_A   movf    tlreg,w		
	andlw   B'10000000'	;zamaskovn tlatka UP
	movwf   reg		;stav tlatka DOWN do reg 
	movf    portb,w 	;naten vstup
	andlw   B'10000000'	;zamaskovn nepotebnch bit
	xorwf   reg,f 		
	btfss   Z 		;test rovnosti
	goto    Cti_tl		;pokud se li tak sko na zatek 		
	movf    tlreg,w						
	andlw   B'00010000'	;zamaskovn tlatka DOWN
	movwf   reg		;stav tlatka UP do reg
	movf    porta,w 	;naten vstupu
	andlw   B'00010000'	;zamaskovn nepotebnch bit
	xorwf   reg,f 		
	btfss   Z 		;test rovnosti
	goto    Cti_tl 		;pokud se li tak sko na zatek 		
	decfsz  cnttl,f 	;dektementace tae filtru zkmit
	goto    Cti_A          	;skok na zatek smyky filtru
	bnk1                   	;vy strnka pamti dat
	movlw   B'00101111'	;obnov pvodn nastaven  
	movwf   trisb		;vstup a vstup
	bnk0         	        ;ni strnka pamti dat
	return          	;nvrat z podprogramu
;*******************************************************
Ref     bnk1			;banka 1
	movlw   0xf0		
	andwf   vrcon,w		;zamaskovn niho niblu
	bnk0			
	iorwf   vref,w		;vy nibl z vrcon
	bnk1			;a ni nibl z vref 
	movwf   vrcon		;se ulo do vrcon
	bnk0			;banka 0
	return 			;nvrat z podprogramu
;*******************************************************
Init    bnk1
	movlw   B'00101111'	 
	movwf   trisb 		;DATA, CLK a STR jsou vstupy
	movlw   B'10100000'
	movwf   vrcon		;konfigurace napov reference
	bnk0
	movlw   B'00010010'	
	movwf   cmcon		;konfigurace bloku kompartor
	movlw   0x00		;disp1 bude zobrazovat 0
	movwf   disp1
	movlw   0x0a
	movwf   disp2	
	movwf   disp3
	movwf   disp4		;disp2-4 budou zhasnut
	movlw   0x00
	movwf   vref
	call    Ref 
;*******************************************************
Main    call    Cti_tl		;nate stav tlatek
	btfsc   UP		;nen-li UP stisknuto
	goto    Main_A		;sko na Main_A
	movlw   0x0f		
	xorwf   vref,w		;otestuje registr vref
	btfss   Z		;nen-li v nm 15 (vref < 15)
	incf    vref,f		;pite k vref 1 
	call    Displej		;zobraz na displeji	
	call    Ref		;zape do registru reference
	call    Cti_tl		;nate stav tlatek
	btfss   UP		
	goto    $-2		;ek na uvolnn tlatka UP
Main_A  call    Cti_tl		;nate stav tlatek
	btfsc   DOWN		;nen-li DOWN stisknuto
	goto    Main_B		;sko na Main_B	
	movf    vref,f		;otestuje registr vref
	btfss   Z		;nen-li v nm 0 (vref > 0)
	decf    vref,f		;odete od vref 1
	call    Displej		;zobraz na displeji	
	call    Ref		;zape do registru reference
	call    Cti_tl		;nate stav tlatek
	btfss   DOWN		
	goto    $-2 		;ek na uvolnn tlatka DOWN 
Main_B  call    Displej		;zobraz na displeji	
	btfsc   C1OUT		;otestuje vstup kompartoru
	goto    Main_C		
	movlw   0x00		;je-li L tak do disp4 zape 0
	movwf   disp4
Main_C  btfss   C1OUT
	goto    Main_D
	movlw   0x01		;je-li H tak do disp4 zape 1
	movwf   disp4
Main_D  goto    Main            ;sko na zatek smyky
;*******************************************************
	end