;****************************************************************
;Program nate teplotu z inteligentnho idla TCN75             *
;a zobraz ji na displeji					*
;---------------------------------------------------------------*
;Nastaven EDUKITu BETA:				        *	
;DISPLAY, I2C_CLK, I2C_DATA : ON		                * 
;ostatn: OFF                                                   *
;---------------------------------------------------------------*
;autor: ASIX, Tom Musil		datum: 19.11.2002       *
;****************************************************************
w       equ     0
f       equ     1
pcl     equ     0x02
swr     equ     0x03
porta   equ     0x05		;adresa portu A
trisa   equ     0x05
portb   equ     0x06		;adresa portu B
trisb   equ     0x06
disp1   equ     0x20		;pamt pro 1 sedmisegmentovku
disp2   equ     0x21		;pamt pro 2 sedmisegmentovku
disp3   equ     0x22		;pamt pro 3 sedmisegmentovku
disp4   equ     0x23 		;pamt pro 4 sedmisegmentovku
rot1    equ     0x24		;pomocn registr
rot2    equ     0x25
rot3    equ     0x26
rot4    equ     0x27
cntrot  equ     0x28		;pomocn registr
work    equ     0x29		;pomocn registr
cnt1    equ     0x2a		;registr asov smyky
cnt2    equ     0x2b		;registr asov smyky
cnt3    equ     0x2c		;registr asov smyky
cntbit  equ     0x70            ;citac vyslanych/prijatych bitu  !! 
i2cdata equ     0x71            ;data I2C sbrnice
flags   equ     0x72            ;stavove slovo
tepll   equ     0x73		;doln byte teploty
teplh   equ     0x74		;horn byte teploty
config  equ     0x75		;registr pro konfiguraci idla
latchb  equ     0x76		;zchytn registr portu B
;*********************************************
#define RP0     swr,5
#define RP1     swr,6
#define C       swr,0
#define Z       swr,2
#define ACK     flags,7		;potvrzen na I2C sbrnici
#define SDA     portb,5		;data I2C sbrnice
#define SCL     portb,0		;hodiny I2C sbrnice
#define STR     latchb,6	;signl strobe obvodu 4094	
#define DATA    latchb,7	;signl data obvodu 4094	
#define CLK     latchb,4 	;hodinov signl obvodu 4094
;*********************************************
bnk0    macro
	bcf     RP0
	bcf     RP1
	endm
bnk1    macro
	bsf     RP0
	bcf     RP1
	endm
;**********************************************
	list    p=16f627
	__config 0x3ff1
;**********************************************
	org     0x0000
	goto    Init
;**********************************************
Cekej   movlw   0x04		;procedura ekn
	movwf   cnt1
Cek_A   movlw   0xff
	movwf   cnt2
Cek_B   movlw   0xff
	movwf   cnt3
	decfsz  cnt3,f
	goto    $-1
	decfsz  cnt2,f
	goto    Cek_B
	decfsz  cnt1,f
	goto    Cek_A
	return
;**********************************************
Tab1    addwf   pcl,f           ;pite w k tai instrukc
	retlw   B'00000011'     ; zobraz 0
	retlw   B'10011111'     ; zobraz 1
	retlw   B'00100101'     ; zobraz 2
	retlw   B'00001101'     ; zobraz 3
	retlw   B'10011001'     ; zobraz 4
	retlw   B'01001001'     ; zobraz 5
	retlw   B'01000001'     ; zobraz 6
	retlw   B'00011111'     ; zobraz 7
	retlw   B'00000001'     ; zobraz 8
	retlw   B'00001001'     ; zobraz 9
	retlw   B'11111111'	; przdn displej
	retlw   B'01100011'	; zobraz C
;*******************************************************
I2cst   bnk1			;banka 1 
	bsf     SCL		;SCL do H (zapis do tris registru!)
	bsf     SDA		;SDA do H 
	bcf     SDA		;SDA do L
	nop
	bcf     SCL		;SCL do L
	bcf     RP0		
	return
;**********************************************
I2csp   bnk1			;banka 1		
	bcf     SCL		;SCL do L (zapis do tris registru!) 		
	bcf     SDA		;SDA do L
	bsf     SCL		;SCL do H
	bcf     RP0		
	btfss   SCL		
	goto    $-1		;ek dokud SCL nen v H (busy I2C sbrnice)
	bsf     RP0		
	bsf     SDA		;SDA do H
	bcf     RP0 		
	return
;**********************************************
I2ctr   movlw   0x08
	movwf   cntbit		;zape 8 do tae smyky
I2ctr_A rlf     i2cdata,f	;rotuje registr dat
	bnk1			
	bcf     SDA		;SDA do L		
	btfsc   C		;testuje bit C, pokud je C=H
	bsf     SDA		;pak SDA do H
	bsf     SCL		;SCL do H
	bcf     RP0		
	btfss   SCL		
	goto    $-1		;ek na uvolnn SCL (busy I2C sbrnice)
	bsf     RP0
	bcf     SCL		;SCL do L
	decfsz  cntbit,f	;odete 1 od tae smyky
	goto    I2ctr_A		;a sko na zatek smyky
	bsf     SCL		;SCL do H
	bcf     SDA		;SDA do L
	bcf     RP0		
	btfss   SCL		
	goto    $-1		;ek na uvolnn SCL (busy I2C sbrnice)
	bsf     ACK		;bit ACK do H
	btfsc   SDA		;testuje SDA, pokud je SDA=H
	bcf     ACK		;pak ACK do L (nepilo potvrzen)
	bsf     RP0
	bcf     SCL		;SCL do L
	bcf     RP0		
	return 
;**********************************************
I2cre   bnk1			
	bsf     SDA		;SDA do H
	movlw   0x08				
	movwf   cntbit		;zape 8 do tae smyky
	bsf     RP0		
I2cre_A bsf     SCL		;SCL do H
	bcf     RP0		
	btfss   SCL		
	goto    $-1		;ek na uvolnn SCL (busy I2C sbrnice)
	bcf     C		;C do L
	btfsc   SDA		;testuje SDA, pokud je SDA=H
	bsf     C		;pak C do H
	rlf     i2cdata,f	;rotuje a zapisuje zleva do i2cdata bit C  
	bsf     RP0		
	bcf     SCL		;SCL do L
	decfsz  cntbit,f	;odete 1 od tae smyky
	goto    I2cre_A		;a sko na zatek smyky
	btfsc   ACK		;testuje nastaven ACK bitu
	bcf     SDA		;pokud je ACK=H pak SDA do L
	bsf     SCL		;SCL do H
	bcf     RP0
	btfss   SCL		
	goto    $-1		;ek na uvolnn SCL (busy I2C sbrnice)
	bsf     RP0
	bcf     SCL		;SCL do L
	bcf     RP0
	return
;**********************************************
Rdtmp   call    I2cst		;start sekvence na I2C
	movlw   B'10010010'
	movwf   I2cdata		;pprava dat
	call    I2ctr		;vysln dat na I2C
	movlw   0x00
	movwf   I2cdata		;pprava dat		
	call    I2ctr		;vysln dat na I2C	
	call    I2cst
	movlw   B'10010011'
	movwf   I2cdata		;pprava dat
	call    I2ctr		;vysln dat na I2C
	bsf     ACK		;MASTER po pjmu vyle ACK 
	call    I2cre		;pjem vyho bytu teploty
	movf    I2cdata,w
	movwf   teplh
	bcf     ACK		;MASTER po pjmu nevyle ACK (ukonen komunikace) 
	call    I2cre		;pjem niho bytu teploty	
	movf    I2cdata,w
	movwf   tepll
	call    I2csp		;stop sekvence na I2C
	return 
;**********************************************
Displej bcf     STR		;STR do L
	movf    latchb,w	;zpis na port pomoc		
	movwf   portb		;zchytnho registru
	movf    disp1,w		;podle hodnoty v disp1 se vygeneruje
	call    Tab1		;kd znaku
	movwf   rot1
	movf    disp2,w		;podle hodnoty v disp2 se vygeneruje
	call    Tab1		;kd znaku
	movwf   rot2
	movf    disp3,w
	call    Tab1
	andlw   B'11111110'	;desetinn teka
	movwf   rot3
	movf    disp4,w
	call    Tab1
	movwf   rot4
	movlw   0x20		;smyka probhne 32x (4 sedmisegmentovky
	movwf   cntrot		;po 8 bitech)
Disp_A  rrf     rot1,f		;rotace 32 bitovho registru (4x8)
	rrf     rot2,f
	rrf     rot3,f
	rrf     rot4,f
	bsf     DATA		;DATA do H
	btfss   C		;testuje C, pokud je C=L
	bcf     DATA		;pak DATA do L
	movf    latchb,w	;zpis na port pomoc
	movwf   portb		;zchytnho registru
	bcf     CLK		;CLK
	movf    latchb,w	;zpis na port pomoc
	movwf   portb		;zchytnho registru
	nop
	bsf	CLK		;CLK do H
	movf    latchb,w	;zpis na port pomoc
	movwf   portb		;zchytnho registru
	decfsz  cntrot,f	;odete 1 od tae smyky	
	goto    Disp_A		;a sko na zatek smyky
	bsf     STR		;STR do H
	movf    latchb,w	;zpis na port pomoc
	movwf   portb		;zchytnho registru
	return 
;*******************************************************
Init    bnk1
	movlw   B'00101111'
	movwf   trisb		;DATA, CLK a STR jsou vstupy
	bnk0
	movlw   B'11011110'	
	movwf   latchb		;zpis do zchytnho registru
	movwf   portb		;bity SDA a SCL vstupnho registru jsou v 0		
	movlw   0x0b		
	movwf   disp1		;posledn sedmisegmentovka bude zobrazovat C
	movlw   0x00		
	movwf   disp2		
	movwf   disp3
	movwf   disp4		;ulo 0 do disp2-4
	call    Displej		;podprogram zobrazen na displeji
;**********************************************
Main    call    Rdtmp		;podprogram naten teploty z idla
	btfss   teplh,7		;pokud nen hodnota zporn
	goto    Main_A		;sko na Main_A
	clrf    teplh		;jinak vynuluje registry teploty	
	clrf    tepll		
Main_A  clrf    disp2		
	clrf    disp3
	clrf    disp4		;vynuluje registry disp2-4
	movf    teplh,w		
	movwf   work		;kopruje teplh do work 
	movlw   0x0a		
	incf    disp4,f		;disp4 inkrementuje o 1
	subwf   work,f		;odete 10 od registru work
	btfsc   C		;pokud je vsledek vt ne 0 
	goto    $-3		;tak sko zpt na instrukci incf disp4,f
	decf    disp4,f		;jinak dekrementuje disp4
	addwf   work,w		;a pite k registru work jedniku 
	movwf   disp3		;zbytek z registru work ulo do disp3
	btfss   tepll,7		;testuje bit znamenajc 0,5C
	goto    $+3		
	movlw   0x05
	movwf   disp2		;kdy je nastaven, tak do disp2 ulo 5 
	call    Displej		;podprogram zobrazen na displeji 	
	call    Cekej		;podprogram ekn (uruje periodu natn dat)
	goto    Main		;zpt na zatek hlavn smyky
;**********************************************
	end
